/*:
# **Kapitel 4.4**
## Aufgabe 2 Taschenlampe
*/
/*:
Eine Taschenlampe verfügt nur über einen einzigen Knopf. Das Attribut zustand vom
Typ ZEICHENKETTE kann die drei Werte „aus“, „an“ und „blinkend“ annehmen.
Das Drücken des Schalters soll durch den Aufruf der Methode *SchalterDrücken()*
simuliert werden.\
a\
Zeichne den fehlenden Teil des Struktogramms in dein Heft.\
b\
Implementiere die Methode *SchalterDrücken()* anhand des Struktogramms
übersichtlich im vorgegebenen Projekt.*/
/**
Stellt eine Taschenlampe dar

- author: Albert Wiedemann
- version: 1.0
 */
class Taschenlampe
{
    /** Lampe */
    var lampe: Dreieck
    /** Zustand */
    var zustand: String
    
    /**
    Legt die benötigten Objekte an und richtet sie ein.
    */
    init ()
    {
        let hintergrund = Rechteck()
        hintergrund.GrößeSetzen(breite: 800, höhe: 600)
        hintergrund.PositionSetzen(x: 0, y: 0)
        hintergrund.FarbeSetzen(farbe: "weiß")

        lampe = Dreieck()
        lampe.GrößeSetzen(breite: 200, höhe: 200)
        lampe.PositionSetzen(x: 100, y: 200)
        lampe.Drehen(grad: -90)
        lampe.FarbeSetzen(farbe: "weiß")

        let schirmVorne = Rechteck()
        schirmVorne.GrößeSetzen(breite: 50, höhe: 200)
        schirmVorne.PositionSetzen(x: 100, y: 200)
        schirmVorne.FarbeSetzen(farbe: "grau")

        let schirmHinten = Dreieck()
        schirmHinten.GrößeSetzen(breite: 200, höhe: 200)
        schirmHinten.PositionSetzen(x: 250, y: 200)
        schirmHinten.Drehen(grad: -90)
        schirmHinten.FarbeSetzen(farbe: "grau")
        
        let korpus = Rechteck()
        korpus.GrößeSetzen(breite: 300, höhe: 100)
        korpus.PositionSetzen(x: 200, y: 250)
        korpus.FarbeSetzen(farbe: "grau")
        
        let schalter = Rechteck()
        schalter.GrößeSetzen(breite: 75, höhe: 25)
        schalter.PositionSetzen(x: 300, y: 225)
        schalter.FarbeSetzen(farbe: "schwarz")
        
        zustand = "aus"
    }
    
    /**
    Schaltet die Taschenlampe aus
    */
    func Ausschalten()
    {
        lampe.FarbeSetzen(farbe: "weiß")
        zustand = "aus"
    }
    
    /**
    Schaltet die Taschenlampe ein
    */
    func Einschalten()
    {
        lampe.FarbeSetzen(farbe: "gelb")
        zustand = "ein"
    }
    
    /**
    Schaltet die Taschenlampe blinkend
    */
    func Blinken()
    {
        lampe.FarbeSetzen(farbe: "orange")
        zustand = "blinkend"
    }
    
    /**
    Schaltet die Taschenlampe gemäß der Vorgabe weiter
    */
    func SchalterDrücken()
    {
//#-editable-code


//#-end-editable-code
    }
}
//#-editable-code
Taschenlampe()
//#-end-editable-code
