/*:
# **Kapitel 4.4**
## Aufgabe 5 Krümel und Monster (Teil 2)
*/
/*:
In der Klasse MONSTER gibt es bereits die Methoden *GeschlossenGelb()*, *GeschlossenOrange()*,
*GeschlossenRot()* und *GeschlossenGrün()*, die das Monstersymbol mit geschlossenem Mund
in der jeweiligen Farbe darstellen.\
a\
Überlege, was das Ausführen des nebenstehenden Struktogramms bei einem Objekt der Klasse MONSTER bewirkt.
Überlege weiter, von welcher Annahme dabei ausgegangen wird.*/
/**
Verwaltet das Monster

- author: Albert Wiedemann
- version: 1.0
 */
class Monster: Figur
{
    /**
    Stellt das gelb gefärbte Monster mit geschlossenem Mund dar.
    */
    func GeschlossenGelb()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "gelb")
        FigurteilFestlegenRechteck(x: 0, y: -2, breite: 50, höhe: 4, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das orange gefärbte Monster mit geschlossenem Mund dar.
    */
    func GeschlossenOrange()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "orange")
        FigurteilFestlegenRechteck(x: 0, y: -2, breite: 50, höhe: 4, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das rot gefärbte Monster mit geschlossenem Mund dar.
    */
    func GeschlossenRot()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "rot")
        FigurteilFestlegenRechteck(x: 0, y: -2, breite: 50, höhe: 4, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das grün gefärbte Monster mit geschlossenem Mund dar.
    */
    func GeschlossenGrün()
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "grün")
        FigurteilFestlegenRechteck(x: 0, y: -2, breite: 50, höhe: 4, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }

    /**
    Stellt das Monster in der angegebenen Farbe mit offenem Mund dar.
    - parameters:
    	- farbe: die gewünschte Farbe
    */
    func Offen(farbe: String)
    {
        EigeneFigurLöschen()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: farbe)
        FigurteilFestlegenDreieck(x1: 0, y1: 0, x2: 50, y2: -10, x3: 50, y3: 10, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: 10, y: -40, breite: 20, höhe: 20, farbe: "schwarz")
    }
/*:
b\
Erstelle in der Klasse MONSTER eine Methode *Schließen(ZEICHENKETTE farbe)*, deren Rumpf
das Struktogramm aus a) ausführt.*/
//#-editable-code


//#-end-editable-code
/*:
c\
Teste die Methode *Schließen* mit verschiedenen Farben. Wähle dabei auch „nicht vorgesehene“ Farben
und beobachte, was die Methode dann bewirkt. Erkläre das Resultat.\
d\
Für Schnelle: In der Klasse MONSTER gibt es auch die Methode *Offen(Zeichenkette farbe)*, die das
Monstersymbol mit offenem Mund in der jeweiligen Farbe darstellt. Entwirf eine Methode
*Öffnen(ZEICHENKETTE farbe)*, die mit Hilfe von *Offen* das Monstersymbol mit geöffnetem Mund darstellt
und zusätzlich absichert, dass nur die Farben gelb, rot, orange und grün zugelassen werden.
Implementiere die Methode.*/
//#-editable-code


//#-end-editable-code
/*:
e\
Für ganz Schnelle: Vergleiche den Aufbau der Methoden *Schließen* und *Öffnen* und nenne jeweils einen
Vorteil für die Vorgehensweise.*/
}
//#-editable-code
let monster = Monster()
monster.GeschlossenGelb()
//#-end-editable-code

